/*
 * Author: Blivervat 
 * createTime: 2017-08-25 11:30:02 
 * Last Modified by:   Blivervat 
 * Last Modified time: 2017-08-25 11:30:02 
 */

import fabric from './fabric.min.js'
import history from './history'
import Vue from 'vue'
// 全局变量，获取鼠标位置
let mouse = {
  x: 0,
  y: 0
}
// const fabric = fabric
const clone = fabric.util.object.clone
const draw = {}
draw.mouse = {
  x: 0,
  y: 0
}
const getRandomInt = (min, max) => {
  return Math.floor(Math.random() * (max - min + 1)) + min
}
const pad = (str, length) => {
  while (str.length < length) {
    str = '0' + str
  };
  return str
}
const getRandomColor = () => {
  return (pad(getRandomInt(0, 255).toString(16), 2) + pad(getRandomInt(0, 255).toString(16), 2) + pad(getRandomInt(0, 255).toString(16), 2))
}
const getRandomLeftTop = () => {
  var offset = 50;
  return {
    left: fabric.util.getRandomInt(0 + offset, 700 - offset),
    top: fabric.util.getRandomInt(0 + offset, 500 - offset)
  }
}
const capitalize = (string) => {
  return string.charAt(0).toUpperCase() + string.slice(1)
}
const getRandomNum = (min, max) => {
  return Math.random() * (max - min) + min
}
let canvas = null

draw.init = (_canvas, callback) => {
  canvas = _canvas
  const render = () => {
    canvas.renderAll();
  }
  canvas.on('object:selected', callback)
  .on('selection:cleared', callback)
  .on('group:selected', callback)
  .on('path:created', callback)
  // 监听鼠标位置，用于复制粘贴（现在不跟随鼠标复制粘贴，所以注释）
  // .on('mouse:move', (option) => {
  //   let {x,y} = canvas.getPointer(option.e)
  //   Object.assign(mouse,{x,y})
  //   // Object.assign(draw.mouse,{x,y})
  //   // console.log('mouse', draw.mouse)
  // })
  .on(
    {
    'object:moving': function objMove(e) {
        let obj = canvas.getActiveObject()
        if (obj.opacity === 1) {
            e.target.opacity = 0.588;
        }                  
    },
    'object:modified': function objModi(e) {
        let obj = canvas.getActiveObject()
        if (obj.opacity === 0.588) {
            e.target.opacity = 1;
        } 
    }
  })
  history.delEvent(canvas)
  history.useEvent(canvas)
  let box = canvas.wrapperEl //upperCanvasEl
  box.setAttribute('tabindex', 1)
  box.addEventListener('blur', () => {
    setTimeout(() => {
      document.oncopy = null;
      document.onpaste = null;
      document.oncut = null;
    }, 300);
  }, false)

  // box.onkeydown = draw.keydown;

  box.onfocus = () => {
    document.oncopy = draw.copy;
    document.onpaste = draw.paste;
    document.oncut = (e) => draw.copy(e, true);
  }

  let ismouseDown = false;
  let obj = null,
    linkObj = null;
  let sp = {
    x: 0,
    y: 0
  }
  // canvas.drawMode=true
  // const down = (ev) => {
  //   obj = null, linkObj = null;
  //   // if (!canvas.drawMode) {
  //   //   if (canvas.drawMode != 'link' && (canvas.getActiveObject() || canvas.getActiveGroup())) return;
  //   // }
  //   ismouseDown = true;
  //   sp = {
  //     x: ev.e.layerX,
  //     y: ev.e.layerY
  //   }
  //   switch (canvas.drawMode) {
  //     case 'line':
  //       obj = draw.addLine([sp.x, sp.y, sp.x, sp.y]);
  //       break;
  //     case 'rect':
  //       obj = draw.addRect({
  //         left: sp.x,
  //         top: sp.y,
  //         width: 1,
  //         height: 1,
  //         fill: '#fff',
  //         setroke: 'red'
  //       });
  //       break;
  //     case 'circle':
  //       obj = draw.addCircle({
  //         left: sp.x,
  //         top: sp.y,
  //         radius: 1,
  //         fill: '#fff',
  //         stroke: 'red'
  //       });
  //       break;
  //     case 'triangle':
  //       obj = draw.addTriangle({
  //         left: sp.x,
  //         top: sp.y,
  //         width: 1,
  //         height: 1,
  //         fill: '#fff',
  //         stroke: 'red'
  //       });
  //       break;
  //     case 'link':
  //       if (canvas.getActiveObject() && !canvas.getActiveObject().x2) {
  //         let o = linkObj = canvas.getActiveObject();
  //         o.set({
  //           lockMovementX: true,
  //           lockMovementY: true
  //         });
  //         sp = {
  //           x: o.left + (o.width * o.zoomX / 2),
  //           y: o.top + (o.height * o.zoomY / 2)
  //         };
  //         obj = draw.addLine([sp.x, sp.y, sp.x, sp.y], false);
  //         o.link1 ? o.link1.push(obj) : (o.link1 = [obj]);
  //       }
  //       break;
  //   }
  // }
  // const move = (ev) => {
  //   if (canvas.drawMode && ismouseDown && obj) {
  //     switch (canvas.drawMode) {
  //       case 'link':
  //       case 'line':
  //         obj.set({
  //           x2: ev.e.layerX,
  //           y2: ev.e.layerY
  //         });
  //         break;
  //       case 'rect':
  //         obj.set({
  //           width: ev.e.layerX - sp.x,
  //           height: ev.e.layerY - sp.y
  //         });
  //         break;
  //       case 'circle':
  //         obj.set({
  //           radius: (ev.e.layerX - sp.x) / 2
  //         });
  //         break;
  //       case 'triangle':
  //         obj.set({
  //           width: ev.e.layerX - sp.x,
  //           height: ev.e.layerY - sp.y
  //         });
  //         break;
  //     }
  //     obj.setCoords();
  //     canvas.renderAll();
  //   }
  // }
  // const up = (e) => {
  //   if (!ismouseDown || !obj) return;
  //   ismouseDown = false;
  //   if (canvas.drawMode == 'link') {
  //     linkObj && linkObj.set({
  //       lockMovementX: false,
  //       lockMovementY: false
  //     });
  //     let o = getObjectByPoint(e.e.layerX, e.e.layerY);
  //     if (!o) {
  //       canvas.remove(obj);
  //       return;
  //     } else {
  //       obj.set({
  //         x2: o.left + (o.width * o.zoomX / 2),
  //         y2: o.top + (o.height * o.zoomY / 2)
  //       });
  //       o.link2 ? o.link2.push(obj) : (o.link2 = [obj]);
  //     }
  //     canvas.sendToBack(obj);
  //     return;
  //   }
  //   obj.active = true;
  //   (e.e.layerX == sp.x && e.e.layerY == sp.y) && canvas.remove(obj);
  // }
  // const objMove = (ev) => {
  //   let o = ev.target;
  //   if (o.link1 && o.link1.length > 0) {
  //     o.link1.map(x => x.set({
  //       x1: o.left + (o.width * o.zoomX / 2),
  //       y1: o.top + (o.height * o.zoomY / 2)
  //     }))
  //   }
  //   if (o.link2 && o.link2.length > 0) {
  //     o.link2.map(x => x.set({
  //       x2: o.left + (o.width * o.zoomX / 2),
  //       y2: o.top + (o.height * o.zoomY / 2)
  //     }))
  //   }
  // }
  // canvas.on('mouse:down', (ev) => down(ev)).on('mouse:move', (ev) => move(ev)).on('mouse:up', (ev) => up(ev)).on('object:moving', (ev) => objMove(ev)).on('object:modified', (ev) => objMove(ev))
}
const getObjectByPoint = (x, y) => {
  let items = canvas.getObjects();
  let objs = [];
  items && items.map((o) => {
    if (!o.x2 && !o.y2 && o.left < x && o.top < y && (o.left + o.width * o.zoomX) > x && (o.top + o.height * o.zoomY) > y) objs.push(o)
  })
  return objs.length == 1 ? objs[0] : null;
}
draw.render = () => {
  canvas.renderAll()
}
// 组件属性设置

const getActiveProp = (name) => {
  if (!canvas) return '';
  var object = canvas.getActiveObject();
  if (!object) return '';
  return object[name] || '';
}
const setActiveProp = (name, value) => {
  if (!canvas) return '';
  var object = canvas.getActiveObject();
  if (!object) return;
  object.set(name, value).setCoords();
  canvas.renderAll();
}
const getActiveStyle = (styleName, object) => {
  if (!canvas) return '';
  object = object || canvas.getActiveObject();
  if (!object) return '';
  return (object.getSelectionStyles && object.isEditing) ? (object.getSelectionStyles()[styleName] || '') : (object[styleName] || '')
}
const setActiveStyle = (styleName, value, object) => {
  if (!canvas) return '';
  object = object || canvas.getActiveObject();
  if (!object) return;
  if (object.setSelectionStyles && object.isEditing) {
    var style = {};
    style[styleName] = value;
    object.setSelectionStyles(style);
    object.setCoords();
  } else {
    if (object._objects && styleName !== 'shadow') {
      object._objects.forEach((obj, index) => {
        obj.set(styleName, value)
      })
    } else {
     object.set(styleName, value)
    }
  }
  object.setCoords();
  canvas.renderAll();
}

draw.setActiveStyle = setActiveStyle;
draw.getActiveStyle = getActiveStyle;
draw.getActiveProp = getActiveProp;
draw.setActiveProp = setActiveProp;
draw.getOpacity = () => {
  return getActiveStyle('opacity');
}
draw.setOpacity = (value) => {
  setActiveStyle('opacity', parseFloat(value, 10));
}
draw.getFill = () => {
  return getActiveStyle('fill')
}
draw.setFill = (value) => {
  setActiveStyle('fill', value)
}
draw.isBold = () => {
  return getActiveStyle('fontWeight') === 'bold'
}
draw.toggleBold = () => {
  setActiveStyle('fontWeight', getActiveStyle('fontWeight') === 'bold' ? '' : 'bold')
}
draw.isItalic = () => {
  return getActiveStyle('fontStyle') === 'italic'
}
draw.toggleItalic = () => {
  setActiveStyle('fontStyle', getActiveStyle('fontStyle') === 'italic' ? '' : 'italic')
}
draw.toggleFlipX = () => {
  setActiveProp('flipX', !canvas.getActiveObject().flipX)
}
draw.toggleFlipY = () => {
  setActiveProp('flipY', !canvas.getActiveObject().flipY)
}
draw.isUnderline = () => {
  return getActiveStyle('underline')
}
draw.toggleUnderline = () => {
  var value = draw.isUnderline() ? false : true
  console.log(value)
  setActiveStyle('underline', value)
}
draw.isLinethrough = () => {
  return getActiveStyle('linethrough')
}
draw.toggleLinethrough = () => {
  var value = draw.isLinethrough() ? false : true
  console.log(value)
  setActiveStyle('linethrough', true)
}
draw.isOverline = () => {
  return getActiveStyle('textDecoration').indexOf('overline') > -1
}
draw.toggleOverline = () => {
  var value = draw.isOverline() ? getActiveStyle('textDecoration').replace('overline', '') : (getActiveStyle('textDecoration') + ' overline');
  setActiveStyle('textDecoration', value)
}
draw.setLeft = (value) => {
  return setActiveProp('left', value - 0)
}
draw.setTop = (value) => {
  return setActiveProp('top', value - 0)
}
draw.getLeft = () => {
  return getActiveProp('left')
}
draw.getTop = () => {
  return getActiveProp('top')
}
draw.getText = () => {
  return getActiveProp('text')
}
draw.setText = (value) => {
  setActiveProp('text', value)
}
draw.getTextAlign = () => {
  return capitalize(getActiveProp('textAlign'))
}
draw.setTextAlign = (value) => {
  setActiveProp('textAlign', value.toLowerCase())
}
draw.getFontFamily = () => {
  return getActiveProp('fontFamily').toLowerCase()
}
draw.setFontFamily = (value) => {
  setActiveProp('fontFamily', value.toLowerCase())
}
draw.getBgColor = () => {
  return getActiveProp('backgroundColor')
}
draw.setBgColor = (value) => {
  setActiveProp('backgroundColor', value)
}
draw.getTextBgColor = () => {
  return getActiveProp('textBackgroundColor')
}
draw.setTextBgColor = (value) => {
  setActiveProp('textBackgroundColor', value)
}
draw.getStroke = () => {
  return getActiveStyle('stroke')
}
draw.setStroke = (value) => {
  setActiveStyle('stroke', value)
}
draw.getStrokeWidth = () => {
  return parseInt(getActiveStyle('strokeWidth'))
}
draw.setStrokeWidth = (value) => {
  setActiveStyle('strokeWidth', parseInt(value, 10))
}
draw.getFontSize = () => {
  return getActiveStyle('fontSize')
}
draw.setFontSize = (value) => {
  setActiveStyle('scaleX', Math.floor(value*100/12)/100)
  setActiveStyle('scaleY', Math.floor(value*100/12)/100)
}
draw.getLineHeight = () => {
  return getActiveStyle('lineHeight')
}
draw.setLineHeight = (value) => {
  setActiveStyle('lineHeight', parseFloat(value, 10))
}
draw.getCharSpacing = () => {
  return getActiveStyle('charSpacing')
}
draw.setCharSpacing = (value) => {
  setActiveStyle('charSpacing', value)
}
draw.getBold = () => {
  return getActiveStyle('fontWeight')
}
draw.setBold = (value) => {
  setActiveStyle('fontWeight', value ? 'bold' : '')
}
draw.getCanvasBgColor = () => {
  return canvas.backgroundColor
}
draw.setShadow = (value) => {
  setActiveStyle('shadow', value)
}
draw.setCanvasBgColor = (value) => {
  canvas.backgroundColor = value;
  canvas.renderAll()
}
draw.togglePlay = () => {
  let o = canvas.getActiveObject();
  if (!o || !o.getElement || o.realType!== 'video') return;
  let v = o.getElement();
  v.paused ? v.play() : v.pause();
}
draw.createVideo = (data, _canvas=canvas) => {
  let v = document.createElement('video')
  v.setAttribute('crossOrigin', 'anonymous')
  v.src = data.src;
  setTimeout(_ => {
    v.width = data.width || v.videoWidth;
    v.height = data.height || v.videoHeight;
    var video = new fabric.Image(v, {
      left: data.left || 150,
      top: data.top || 150,
      scaleX: data.scaleX || 0.3,
      scaleY: data.scaleY || 0.3,
      originX: 'center',
      originY: 'center',
      crossOrigin: '*'
    });
    // video.scale(.15, .15).setCoords()
    //设置额外属性
    video.toObject = (function(toObject) {
      return function() {
        return fabric.util.object.extend(toObject.call(this), {
          realType: this.realType
        });
      };
    })(video.toObject);
    video.realType = 'video';
    _canvas.add(video);
    // video.getElement().play();
    fabric.util.requestAnimFrame(function render() {
      _canvas.renderAll();
      fabric.util.requestAnimFrame(render);
    });
  }, 500)
}
draw.createSVG = (o) => {
  let d = o.d || o.path;
  let stroke = o.stroke || '#000000 ';
  let strokeWidth = o.strokeWidth || 1;
  let width = o.width || 100;
  let height = o.height || 100;
  let angle = o.angle || 0;
  let svg = '';
  if (d) {
    svg = `<svg xmlns="http://www.w3.org/2000/svg" ><svg><path fill="${!o.d ? 'none' : o.fill}" transform="scale(${o.zoomX} ${o.zoomY}) translate(${o.skewX} ${o.skewY}) rotate(${angle})" stroke="${stroke}" stroke-width="${strokeWidth}" d="${d}"></path></svg></svg>`;
    draw.loadSVGWithoutGrouping(svg)
  }
  return svg
}


// 画图相关

draw.addRect = (options) => {
  if (typeof options != 'object') return;
  let obj = new fabric.Rect(options);
  canvas.add(obj);
  return obj;
}
draw.addCircle = (options) => {
  if (typeof options != 'object') return;
  let obj = new fabric.Circle(options);
  canvas.add(obj);
  return obj;
}
draw.addTriangle = (options) => {
  if (typeof options != 'object') return;
  let obj = new fabric.Triangle(options);
  canvas.add(obj);
  return obj;
}
draw.addLine = (ops, s = true) => {
  let line = new fabric.Line([ops[0], ops[1], ops[2], ops[3]], {
    fill: 'red',
    stroke: 'red',
    strokeWidth: 2,
    selectable: s
  });
  canvas.add(line);
  return line;
}
draw.addPolygon = () => {
  var coord = getRandomLeftTop();
  this.canvas.add(new fabric.Polygon([{
    x: 185,
    y: 0
  }, {
    x: 250,
    y: 100
  }, {
    x: 385,
    y: 170
  }, {
    x: 0,
    y: 245
  }], {
    left: coord.left,
    top: coord.top,
    fill: '#' + getRandomColor()
  }))
}
draw.addText = (options) => {
  options.originX = 'left';
  options.hasRotatingPoint = true;
  options.centerTransform = true;
  options.hasRotatingPoint = true;
  options.centerTransform = true;
  options.fontFamily = '微软雅黑';
  options.fontWeight = options.fontWeight || '';
  options.width = options.text.length * 16 > 600 ? 600 : options.text.length * 16;
  let text = new fabric.Text(options.text, options);
  let c = ['ml', 'mr', 'mt', 'mb'];
  c.map((x) => {
    text['setControlVisible'](x, false)
  });
  canvas.add(text);
}
draw.addTextbox = (options) => {  
  // options.originX = 'left';
  // options.hasRotatingPoint = true;
  // options.centerTransform = true;
  // options.fontFamily = '微软雅黑';
  // options.fontSize = 12;
  // options.fontWeight = options.fontWeight || '';
  // options.width = options.text.length * 16 > 600 ? 600 : options.text.length * 16;
  let text = new fabric.Textbox(options.text, {fontSize: 12, minWidth: 6, left: 50, top: 50, scaleX: 2, scaleY: 2});
  // let c = ['tl', 'bl', 'mb', 'br', 'tr', 'mt'];
  // c.map((x) => {
  //   text['setControlVisible'](x, false)
  // });
  canvas.add(text);
}
draw.addIText = (options) => {
  options.originX = 'left';
  options.hasRotatingPoint = true;
  options.centerTransform = true;
  options.hasRotatingPoint = true;
  options.centerTransform = true;
  options.fontFamily = '微软雅黑';
  options.fontWeight = options.fontWeight || '';
  options.width = options.text.length * 16 > 600 ? 600 : options.text.length * 16;
  let text = new fabric.IText(options.text, options);
  let c = ['ml', 'mr', 'mt', 'mb'];
  c.map((x) => {
    text['setControlVisible'](x, false)
  });
  canvas.add(text);
}
draw.addShapeByUrl = (svgUrl) => {
  // var coord = getRandomLeftTop();
  fabric.loadSVGFromURL(svgUrl, (objects, options) => {
    var loadedObject = fabric.util.groupSVGElements(objects, options, svgUrl);
    loadedObject.set({
      left: 100,
      top: 100,
      angle: 0,
    }).setCoords();
    loadedObject.toObject = (function(toObject) {
      return function() {
        return fabric.util.object.extend(toObject.call(this), {
          realType: this.realType,
          cover: this.cover
        });
      };
    })(loadedObject.toObject);
    loadedObject.realType = 'svg';
    canvas.add(loadedObject);
  })
}
draw.addImage = (o) => {
  fabric.Image.fromURL(o.src, (image) => {
    image.set(o).scale(o.zoomX || .15, o.zoomY || .15).setCoords();
    canvas.add(image)
  }, {crossOrigin: '*'})
}


// 画布执行型操作

draw.confirmClear = () => {
  if (confirm('清空不能复原，您确定吗?')) {
    canvas.clear();
  }
}
draw.toImage = () => {
  if (!fabric.Canvas.supports('toDataURL')) {
    alert('您的浏览器不支持此项操作！')
  } else {
    return canvas.toDataURL('jpeg')
  }
}
draw.toSVG = () => {
  window.open('data:image/svg+xmlutf8,' + encodeURIComponent(canvas.toSVG()))
}
draw.toJSON = () => {
  draw.setConsoleJSON(JSON.stringify(canvas))
}
draw.getSelected = () => {
  if (!canvas) return '';
  return canvas.getActiveObject()
}
draw.getSelectedGroup = () => {
  if (!canvas) return '';
  return canvas.getActiveObjects()
}
draw.removeSelected = () => {
  var obj = canvas.getActiveObjects()
  obj.map(x => {
    if (x.realType === 'video') {
      x.getElement().pause()
    }
    canvas.remove(x)
  })
  canvas.discardActiveObject();
  canvas.requestRenderAll();
}

// 锁定

draw.toggleLock = () => {
  let value = !getActiveProp('lockRotation');
  // setActiveProp('selectable', value);
  setActiveProp('lockMovementX', value);
  setActiveProp('lockMovementY', value);
  setActiveProp('lockScalingX', value);
  setActiveProp('lockScalingY', value);
  setActiveProp('lockRotation', value);
}
draw.getHorizontalLock = () => {
  return getActiveProp('lockMovementX')
}
draw.setHorizontalLock = (value) => {
  setActiveProp('lockMovementX', value)
}
draw.getVerticalLock = () => {
  return getActiveProp('lockMovementY')
}
draw.setVerticalLock = (value) => {
  setActiveProp('lockMovementY', value)
}
draw.getScaleLockX = () => {
  return getActiveProp('lockScalingX')
}
draw.setScaleLockX = (value) => {
  setActiveProp('lockScalingX', value)
}
draw.getScaleLockY = () => {
  return getActiveProp('lockScalingY')
}
draw.setScaleLockY = (value) => {
  setActiveProp('lockScalingY', value)
}
draw.getRotationLock = () => {
  return getActiveProp('lockRotation')
}
draw.setRotationLock = (value) => {
  setActiveProp('lockRotation', value)
}


// 其他相关属性 ，对齐

draw.getOriginX = () => {
  return getActiveProp('originX')
}
draw.setOriginX = (value) => {
  setActiveProp('originX', value)
}
draw.getOriginY = () => {
  return getActiveProp('originY')
}
draw.setOriginY = (value) => {
  setActiveProp('originY', value)
}
draw.getObjectCaching = () => {
  return getActiveProp('objectCaching')
}
draw.setObjectCaching = (value) => {
  return setActiveProp('objectCaching', value)
}
draw.getNoScaleCache = () => {
  return getActiveProp('noScaleCache')
}
draw.setNoScaleCache = (value) => {
  return setActiveProp('noScaleCache', value)
}
draw.getTransparentCorners = () => {
  return getActiveProp('transparentCorners')
}
draw.setTransparentCorners = (value) => {
  return setActiveProp('transparentCorners', value)
}
draw.getHasBorders = () => {
  return getActiveProp('hasBorders')
}
draw.setHasBorders = (value) => {
  return setActiveProp('hasBorders', value)
}
draw.getHasControls = () => {
  return getActiveProp('hasControls')
}
draw.setHasControls = (value) => {
  return setActiveProp('hasControls', value)
}


// 层级切换

draw.sendBackwards = () => {
  var activeObject = canvas.getActiveObject();
  if (activeObject) {
    canvas.sendBackwards(activeObject)
  }
}
draw.sendToBack = () => {
  var activeObject = canvas.getActiveObject();
  if (activeObject) {
    canvas.sendToBack(activeObject)
  }
}
draw.bringForward = () => {
  var activeObject = canvas.getActiveObject();
  if (activeObject) {
    canvas.bringForward(activeObject)
  }
}
draw.bringToFront = () => {
  var activeObject = canvas.getActiveObject();
  if (activeObject) {
    canvas.bringToFront(activeObject)
  }
}

// 裁剪，阴影

draw.clip = () => {
  var obj = canvas.getActiveObject();
  if (!obj) return;
  if (obj.clipTo) {
    obj.clipTo = null
  } else {
    var radius = obj.width < obj.height ? (obj.width / 2) : (obj.height / 2);
    obj.clipTo = function (ctx) {
      ctx.arc(0, 0, radius, 0, Math.PI * 2, true)
    }
  }
  canvas.renderAll()
}
draw.shadowify = () => {
  var obj = canvas.getActiveObject();
  if (!obj) return;
  if (obj.shadow) {
    obj.shadow = null
  } else {
    obj.setShadow({
      color: 'rgba(0,0,0,0.3)',
      blur: 10,
      offsetX: 10,
      offsetY: 10
    })
  }
  canvas.renderAll()
}
draw.gradientify = () => {
  var obj = canvas.getActiveObject();
  if (!obj) return;
  obj.setGradient('fill', {
    x1: 0,
    y1: 0,
    x2: (getRandomInt(0, 1) ? 0 : obj.width),
    y2: (getRandomInt(0, 1) ? 0 : obj.height),
    colorStops: {
      0: '#' + getRandomColor(),
      1: '#' + getRandomColor()
    }
  });
  canvas.renderAll()
}


// 外部执行
let consoleJSONValue = '';
let consoleSVGValue = '';
let consoleValue = '';
draw.consoleJSONValue = consoleJSONValue;
draw.consoleSVGValue = consoleSVGValue;
draw.consoleValue = consoleValue;

draw.isFullScreen = () => {
  return document.fullscreenEnabled || window.fullScreen || document.webkitIsFullScreen || document.msFullscreenEnabled || false;
} //return document.fullscreenElement || document.msFullscreenElement || document.mozFullScreenElement || document.webkitFullscreenElement || false;}
draw.elementFullScreen = (element) => {
  if (element.requestFullscreen) {
    element.requestFullscreen();
  } else if (element.mozRequestFullScreen) {
    element.mozRequestFullScreen();
  } else if (element.webkitRequestFullscreen) {
    element.webkitRequestFullscreen();
  } else if (element.msRequestFullscreen) {
    element.msRequestFullscreen();
  }
}
draw.resize = (w, h, p = false) => {
  draw.draws.map((c) => {
    c.isPreview = p;
    let cWidth = c.width;
    let cHeight = c.height;
    let ratio = cWidth / cHeight;
    let newHeight = h;
    let newWidth = h * ratio;
    c.setDimensions({
      height: newHeight,
      width: newWidth
    });
    let zoomRatio = newWidth / cWidth;
    c.zoomToPoint({
      x: newHeight / 2,
      y: newWidth / 2
    }, zoomRatio);
    c.viewportTransform[4] = 0;
    c.viewportTransform[5] = 0;
  })
}
draw.toggleFullScreen = (box) => {
  box = box || document.getElementsByClassName('pages')[0];
  if (draw.isFullScreen()) {
    let w = window.screen.width;
    let h = window.screen.height;
    box.style.background = '#000';
    box.style.overflow = 'hidden';
    box.style.padding = '0';
    box.style.margin = '0';
    draw.resize(w, h, true);
  } else {
    box.style = '';
    draw.draws.map((c) => {
      c.isPreview = false;
      c.setDimensions({
        height: draw.height,
        width: draw.width
      });
      c.zoomToPoint({
        x: draw.width / 2,
        y: draw.height / 2
      }, 1);
    })
  }
  draw.render()
}
draw.screenChange = () => {
  let doc = document;
  doc.addEventListener('fullscreenchange', (e) => {
    draw.toggleFullScreen()
  }, false);
  doc.addEventListener('msfullscreenchange', (e) => {
    draw.toggleFullScreen()
  }, false);
  doc.addEventListener('mozfullscreenchange', (e) => {
    draw.toggleFullScreen()
  }, false);
  doc.addEventListener('webkitfullscreenchange', (e) => {
    draw.toggleFullScreen()
  }, false);
}
draw.ondrop = (e) => {
  e.preventDefault();
  var fs = e.dataTransfer.files;
  for (var i = 0; i < fs.length; i++) {
    if (fs[i].type.indexOf('image') != -1) {
      var reader = new FileReader();
      reader.onload = (y) => {
        let o = {
          src: y.target.result,
          zoomX: 1,
          zoomY: 1
        };
        draw.addImage(o);
      };
      reader.readAsDataURL(fs[i]);
    }
  }
}
draw.keydown = (e) => {
  let key = e.keyCode;
  console.log(key)
  if (key == 46 || key == 8) {
    draw.removeSelected();
    return false;
  }
  if (e.ctrlKey) {
    if (e.shiftKey) {
      if (key == 38) {
        draw.bringToFront()
      };
      if (key == 40) {
        draw.sendToBack()
      };
      return;
    }
    if (key == 38) {
      draw.bringForward()
    };
    if (key == 40) {
      draw.sendBackwards()
    };
    if (key == 90) {
      history.undo()
    };
    if (key == 89) {
      history.redo()
    };
    return;
  }
  let obj = draw.getSelected();
  if (!obj) return;
  if (key == 37) {
    let x = obj.left - 1;
    draw.setLeft(x)
    e.preventDefault()
  };
  if (key == 38) {
    let y = obj.top - 1;
    draw.setTop(y)
    e.preventDefault()
  };
  if (key == 39) {
    let x = obj.left + 1;
    draw.setLeft(x)
    e.preventDefault()
  };
  if (key == 40) {
    let y = obj.top + 1;
    draw.setTop(y)
    e.preventDefault()
  };
}
// draw.copyData = null
draw.copy = (e, cut) => {
  e.preventDefault();
  let board = e.clipboardData || window.clipboardData;
  // let gs = canvas.getActiveGroup();
  // let gs = undefined
  let o = canvas.getActiveObjects();
  // console.log('object', o)
  if (!o || o.length < 1) return;
  canvas.getActiveObject().clone(function(cloned) {
     draw.copyData = cloned
     console.log(cloned)
    // draw.copyData = JSON.parse(JSON.stringify(cloned))
    // const text = new fabric.IText('继承原型')
    // text.clone((newClone) => {
    //     console.log('newClone', newClone)
    // })
    // console.log(cloned.__proto__)
    // console.log(text.__proto__)
    // draw.copyData.__proto__ = text.__proto__
	});
  let str = JSON.stringify(o);
  board.setData('text', str); //把数据放进剪切板
  cut && draw.removeSelected();
  // draw.copyData = str;
  return str;
}
draw.paste = (e) => {
  e.preventDefault();
  let board = e.clipboardData;
  var i = 0,
    items, item, types;
  items = board.items;
  if (!items) {
    return
  }
  item = items[0];
  types = board.types || [];
  for (let i = 0; i < types.length; i++) {
    if (types[i] === 'Files') {
      item = items[i];
      break;
    }
  }
  if (item && item.kind === 'file' && item.type.match(/^image\//i)) {
    var file = item.getAsFile(),
      reader = new FileReader();
    reader.onload = (e) => {
      // 上传图片
      let dataURL = e.target.result.split(',')[1]
       draw.getToken().then(token => {
          draw.uploadImage(dataURL, token).then(url => {
              let o = {
              src: url,
              zoomX: 1,
              zoomY: 1
            };
            draw.addImage(o)
          })
      })
    };
    reader.readAsDataURL(file);
    return
  }
  let data = board.getData('text'); // 获取内容
  if (data.indexOf('[{"type":') == 0) {
    draw.reviewJson(draw.copyData, canvas)
    // canvas.loadObjFormJson(o);
  } else if (data !== '[]') {
    draw.addIText({
      text: data,
      fontSize: 14,
      left: 20,
      top: 20
    })
  }
}
draw.reviewJson = (json, canvas) => {
  if (!json || json == '[]') {
      return;
    }
    console.log('克隆函数',json.clone)
  json.clone(function(clonedObj) {
    canvas.discardActiveObject();
		clonedObj.set({
			left: clonedObj.left + 10,
			top: clonedObj.top + 10,
			evented: true,
		});
		if (clonedObj.type === 'activeSelection') {
			// active selection needs a reference to the canvas.
			clonedObj.canvas = canvas;
			clonedObj.forEachObject(function(obj) {
			canvas.add(obj);
			});
			// this should solve the unselectability
			clonedObj.setCoords();
		} else {
			canvas.add(clonedObj);
		}
		json.top += 10;
		json.left += 10;
		canvas.setActiveObject(clonedObj);
		canvas.requestRenderAll();
	});
    // // serialize if it wasn't already
    // var serialized = (typeof json === 'string')
    //   ? JSON.parse(json)
    //   : fabric.util.object.clone(json);
    // // 获取鼠标当前位置
    // serialized = draw.getpoint(serialized, mouse.x, mouse.y)
    // const oldJson = canvas.toJSON()
    // oldJson.objects = oldJson.objects.concat(serialized)
    // canvas.clear()
    // canvas.loadFromJSON(oldJson)
},
draw.getToken = () => {
    return Vue.http.get('user/upload_token').then(res => {
        const { data } = res.body
        return data.token
    })
},
draw.uploadImage = (imgBase, token) => {
    // const image = this.$refs.draw.getImage(0).split(',')[1]
    return Vue.http.post('http://up-z2.qiniu.com/putb64/-1', imgBase, {
        headers: {
            'Content-Type': 'application/octet-stream',
            'Authorization': 'UpToken ' + token
        }
    }).then(res => `http://images.91jianke.com/${res.data.key}`, res => {
        console.log('上传失败')
        this.uploadImage(imgBase, token)
    })
},
// 添加json
draw.loadMoreJson = (json, canvas) => {
  var serialized = (typeof json === 'string')
    ? JSON.parse(json)
    : fabric.util.object.clone(json);
  // 获取鼠标当前位置
  serialized = draw.getpoint(serialized, 200, 200)
  const oldJson = canvas.toJSON()
  oldJson.objects = oldJson.objects.concat(serialized)
  canvas.clear()
  canvas.loadFromJSON(oldJson)
  draw.loadVideo(oldJson, canvas)
},
draw.loadVideo = (data, canvas) => {
  data.objects.map(x => {
      if (x.realType === 'video') {
          setTimeout(() => {
              draw.createVideo(x, canvas)
          }, 1000)
      }
      // if (x.objects) {
      //     draw.loadVideo(x)
      // }   
  })
},
draw.getpoint = (data, x, y) => {
  // 通过第一个组件计算出其他组件相对位置
  let oldx = data[0].left,
      oldy = data[0].top,
      relativeX = x - oldx,
      relativeY = y - oldy
  // console.log(relativeX, relativeY, oldy, oldx, x, y)
  data[0].left = x
  data[0].top = y
  for(let i = 1; i < data.length; i++) {
    data[i].left += relativeX
    data[i].top += relativeY
  }
  return data
},
draw.group = () => {
  const objs = canvas.getActiveObject(),
  _objs = objs.getObjects()
  let g = false
  if (!objs) {
    return
  }
  _objs.map(x => {
    if(x.realType && x.realType === 'video') {
      g = true
    }
  })
  if (g) {
    return
  }
  if (objs.type !== 'activeSelection') {
    return
  }
  objs.toGroup();
  canvas.discardActiveObject();
  canvas.requestRenderAll();
}
draw.ungroup = () => {
  const objs = canvas.getActiveObject()
  if (!objs) {
    return;
  }
  if (objs.type !== 'group') {
    return;
  }
  objs.toActiveSelection();
  canvas.discardActiveObject();
  canvas.requestRenderAll();
}
draw.cancelSelect = () => {
  // 取消当前画布组件
  // let obj = canvas.getActiveObject();
  // let group = canvas.getActiveGroup();
  // obj && (obj.active = false, obj.setCoords());
  // group && (group.active = false, group.setCoords());
  // if (obj) {
  //   var o = obj.getObjects();
  //   let arr = [];
  //   o.forEach(function (object) {
  //     object.active = false
  //   })
  // }
  // canvas.renderAll()
  let obj = canvas.getActiveObject();
  canvas.discardActiveObject();
  canvas.requestRenderAll();
}
draw.getConsoleJSON = () => {
  return consoleJSONValue
}
draw.setConsoleJSON = (value) => {
  consoleJSONValue = value
}
draw.getConsoleSVG = () => {
  return consoleSVGValue
}
draw.setConsoleSVG = (value) => {
  consoleSVGValue = value
}
draw.getConsole = () => {
  return consoleValue
}
draw.setConsole = (value) => {
  consoleValue = value
}
draw.loadSVGWithoutGrouping = (svg) => {
  fabric.loadSVGFromString(svg, (objects) => {
    canvas.add.apply(canvas, objects);
    canvas.renderAll();
  })
}
draw.loadSVG = (svgStr, options) => {
  _loadSVG(svgStr, options)
}
var _loadSVG = (svg, opts) => {
  fabric.loadSVGFromString(svg, (objects, options) => {
    var obj = fabric.util.groupSVGElements(objects, options);
    if (typeof opts === 'object') {
      Object.keys(opts).map(x => obj[x] = opts[x])
    }
    canvas.add(obj).centerObject(obj).renderAll();
    obj.setCoords();
  })
}
draw.saveJSON = () => {
  _saveJSON(JSON.stringify(canvas))
}
var _saveJSON = (json) => {
  draw.setConsoleJSON(json)
}
draw.loadJSON = () => {
  _loadJSON(consoleJSONValue)
}
var _loadJSON = (json) => {
  canvas.loadFromJSON(json, () => {
    canvas.renderAll()
  })
}

//数据输出部分

// 绘图模式
draw.drawMode = (mode) => {
  canvas['drawMode'] = mode;
  canvas.selection = !mode;
}
draw.isDrawingMode = () => {
  return canvas.isDrawingMode
}
draw.getPreserveObjectStacking = () => {
  return canvas.preserveObjectStacking
}
draw.setPreserveObjectStacking = (value) => {
  return canvas.preserveObjectStacking = value
}
draw.getFreeDrawingMode = () => {
  return canvas.isDrawingMode
}
draw.setFreeDrawingMode = (value) => {
  canvas.isDrawingMode = !!value
}
draw.freeDrawingMode = 'Pencil'
draw.getDrawingMode = () => {
  return draw.freeDrawingMode
}
draw.setDrawingMode = (type) => {
  draw.freeDrawingMode = type;
  if (type === 'hline') {
    canvas.freeDrawingBrush = draw.vLinePatternBrush
  } else if (type === 'vline') {
    canvas.freeDrawingBrush = draw.hLinePatternBrush
  } else if (type === 'square') {
    canvas.freeDrawingBrush = draw.squarePatternBrush
  } else if (type === 'diamond') {
    canvas.freeDrawingBrush = draw.diamondPatternBrush
  } else if (type === 'texture') {
    canvas.freeDrawingBrush = draw.texturePatternBrush
  } else {
    canvas.freeDrawingBrush = new fabric[type + 'Brush'](canvas)
  }
}
draw.getDrawingLineWidth = () => {
  if (canvas.freeDrawingBrush) {
    return canvas.freeDrawingBrush.width
  }
}
draw.setDrawingLineWidth = (value) => {
  if (canvas.freeDrawingBrush) {
    canvas.freeDrawingBrush.width = parseInt(value, 10) || 1
  }
}
draw.getDrawingLineColor = () => {
  if (canvas.freeDrawingBrush) {
    return canvas.freeDrawingBrush.color
  }
}
draw.setDrawingLineColor = (value) => {
  if (canvas.freeDrawingBrush) {
    canvas.freeDrawingBrush.color = value
  }
}
draw.getDrawingLineShadowWidth = () => {
  if (canvas.freeDrawingBrush && canvas.freeDrawingBrush.shadow) {
    return canvas.freeDrawingBrush.shadow.blur || 1
  } else {
    return 0
  }
}
draw.setDrawingLineShadowWidth = (value) => {
  if (canvas.freeDrawingBrush) {
    var blur = parseInt(value, 10) || 1;
    if (blur > 0) {
      canvas.freeDrawingBrush.shadow = new fabric.Shadow({
        blur: blur,
        offsetX: 10,
        offsetY: 10
      })
    } else {
      canvas.freeDrawingBrush.shadow = null
    }
  }
}
// 初始化
(() => {
  if (/(iPhone|iPod|iPad)/i.test(navigator.userAgent)) {
    fabric.Object.prototype.cornerSize = 30
  }
})()
draw.getDPI = () => {
  var arrDPI = [];
  if (window.screen.deviceXDPI !== undefined) {
    arrDPI[0] = window.screen.deviceXDPI;
    arrDPI[1] = window.screen.deviceYDPI;
  } else {
    var tmpNode = document.createElement('DIV');
    tmpNode.style.cssText = 'width:1in;height:1in;position:absolute;left:0px;top:0px;z-index:99;visibility:hidden';
    document.body.appendChild(tmpNode);
    arrDPI[0] = parseInt(tmpNode.offsetWidth);
    arrDPI[1] = parseInt(tmpNode.offsetHeight);
    tmpNode.parentNode.removeChild(tmpNode);
  }
  return arrDPI;
}
export default draw
